#pragma once

namespace Tmpl8 {

class Game
{
public:
	void SetTarget( Surface* surface ) { screen = surface; }
	void Init() {}
	void Shutdown() { screen->Clear( 0 ); }
	void Tick( float deltaTime );
	void MouseUp( int button ) { /* implement if you want to detect mouse button presses */ }
	void MouseDown( int button ) { /* implement if you want to detect mouse button presses */ }
	void MouseMove( int x, int y ) { /* implement if you want to detect mouse movement */ }
	void KeyUp( int key ) { /* implement if you want to handle keys */ }
	void KeyDown( int key ) { /* implement if you want to handle keys */ }
private:
	Surface* screen;
};

#if 0

// HIDDEN IN PLAIN SIGHT

	// spawn the worker threads
	initworkers();
#if 1
	theScreen = screen;
	remaining = tileCount;
	for( int i = 0; i < THREADCOUNT; i++ ) SetEvent( goSignal[i] );
	WaitForMultipleObjects( THREADCOUNT, doneSignal, true, INFINITE );
#else
#endif

HANDLE goSignal[THREADCOUNT], doneSignal[THREADCOUNT];
volatile LONG remaining = 0;
Surface* theScreen = 0;

unsigned long __stdcall workerthread( LPVOID param )
{
	int threadId = *(int*)param;
	int xtiles = SCRWIDTH / TILESIZE, ytiles = SCRHEIGHT / TILESIZE;
	int tileCount = xtiles * ytiles;
	while (1)
	{
		// worker threads start in hibernation
		WaitForSingleObject( goSignal[threadId], INFINITE );
		// fight for food
		while (remaining > 0)
		{
			int task = (int)InterlockedDecrement( &remaining ) - 1;
			if (task >= 0)
			{
				int tx = task % xtiles;
				int ty = task / xtiles;
				drawtile( theScreen, tx * TILESIZE, ty * TILESIZE );
			}
		}
		// let the main thread know we're done
		SetEvent( doneSignal[threadId] );
	}
}

void initworkers()
{
	static HANDLE worker[THREADCOUNT];
	static DWORD threadId[THREADCOUNT];
	static int params[THREADCOUNT];
	static bool workersRunning = false;
	if (workersRunning) return;
	// spawn worker threads
	for( int i = 0; i < THREADCOUNT; i++ )
	{
		params[i] = i;
		worker[i] = CreateThread( NULL, 0, workerthread, &params[i], 0, &threadId[i] );
		// SetThreadAffinityMask( worker[i], 1 << i );
	}
	// create bookkeeping events
	for( int i = 0; i < THREADCOUNT; i++ )
	{
		goSignal[i] = CreateEvent( NULL, false, false, NULL ); 
		doneSignal[i] = CreateEvent( NULL, false, false, NULL ); 
	}
	workersRunning = true;
}

#endif

}; // namespace Tmpl8